!define VER_MAJOR 1
!define VER_MINOR 43

!define MUI_PRODUCT "Album List" ;Define your own software name here
!define MUI_VERSION "${VER_MAJOR}.${VER_MINOR}" ;Define your own software version here

!include "MUI.nsh"

;--------------------------------
;Configuration

  ;General
  OutFile AlbumListv${VER_MAJOR}${VER_MINOR}.exe

  ;Folder selection page
  InstallDir $PROGRAMFILES\Winamp
  
  ;Remember install folder
  InstallDirRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Winamp" "UninstallString"

  ;Install types
  InstType "Full"
  InstType "Normal"
  InstType "Lite"

  BrandingText " "
  SetCompressor bzip2
  SetDatablockOptimize on
  SetDateSave on
  SetOverwrite on
  CRCCheck on
  WindowIcon off

;--------------------------------
;Modern UI Configuration

  !define MUI_WELCOMEPAGE
  !define MUI_LICENSEPAGE
  !define MUI_COMPONENTSPAGE
    !define MUI_COMPONENTSPAGE_SMALLDESC
  !define MUI_DIRECTORYPAGE
  !define MUI_FINISHPAGE
    !define MUI_FINISHPAGE_SHOWREADME "$INSTDIR\Plugins\Album List\readme.htm"
    !define MUI_TEXT_FINISH_RUN "Run Winamp"
	!define MUI_FINISHPAGE_RUN  "$INSTDIR\winamp.exe"
    !define MUI_FINISHPAGE_NOREBOOTSUPPORT
  
  !define MUI_ABORTWARNING
  
  !define MUI_UNINSTALLER
  !define MUI_UNCONFIRMPAGE

  !define MUI_SPECIALBITMAP "${NSISDIR}\Contrib\Icons\modern-wizard llama.bmp"
  
;--------------------------------
;Languages
 
  !define MUI_BRANDINGTEXT " "
  !insertmacro MUI_LANGUAGE "English"
  
;--------------------------------
;Language Strings

  ;Description
  LangString DESC_SecCore ${LANG_ENGLISH} "The core files required to use Album List"
  LangString DESC_SecLanguages ${LANG_ENGLISH} "Optional languages files"

;--------------------------------
;Data
  
  LicenseData license.txt

;--------------------------------
;Installer Sections

Section "Album List Plugin (required)" SecCore

  ;ADD YOUR OWN STUFF HERE!

  SectionIn 1 2 3 RO

  SetOutPath $INSTDIR\Plugins
  File Release\gen_m3a.dll

  SetOutPath "$INSTDIR\Plugins\Album List"
  File readme\readme.htm
  File readme\nav_div.gif
  File readme\nav_div_left.gif
  File readme\nav_div_right.gif
  File readme\searchpath.gif
  File history.txt

  SetOutPath "$INSTDIR\Plugins\Album List\Templates"
  File export.htt
  File cover.htt

SectionEnd

SubSection "Language Files" SecLanguages
  
  Section "Bulgarian" SecBulgarian
  SectionIn 1 2
  SetOutPath "$INSTDIR\Plugins\Album List\Language"
  File "languages\bulgarian.al"
  SectionEnd

  Section "Catalan" SecCatalan
  SectionIn 1 2
  SetOutPath "$INSTDIR\Plugins\Album List\Language"
  File "languages\catalan.al"
  SectionEnd

  Section "Chinese (Simplified)" SecChineseS
  SectionIn 1 2
  SetOutPath "$INSTDIR\Plugins\Album List\Language"
  File "languages\simplified chinese.al"
  SectionEnd

  Section "Chinese (Traditional)" SecChineseT
  SectionIn 1 2
  SetOutPath "$INSTDIR\Plugins\Album List\Language"
  File "languages\traditional chinese.al"
  SectionEnd

  Section "Czech" SecCzech
  SectionIn 1 2
  SetOutPath "$INSTDIR\Plugins\Album List\Language"
  File "languages\czech.al"
  SectionEnd

  Section "Danish" SecDanish
  SectionIn 1 2
  SetOutPath "$INSTDIR\Plugins\Album List\Language"
  File "languages\danish.al"
  SectionEnd

  Section "Dutch" SecDutch
  SectionIn 1 2
  SetOutPath "$INSTDIR\Plugins\Album List\Language"
  File "languages\dutch.al"
  SectionEnd

  Section "Faroese" SecFaroese
  SectionIn 1 2
  SetOutPath "$INSTDIR\Plugins\Album List\Language"
  File "languages\faroese.al"
  SectionEnd

  Section "Finnish" SecFinnish
  SectionIn 1 2
  SetOutPath "$INSTDIR\Plugins\Album List\Language"
  File "languages\finnish.al"
  SectionEnd

  Section "French" SecFrench
  SectionIn 1 2
  SetOutPath "$INSTDIR\Plugins\Album List\Language"
  File "languages\french.al"
  SectionEnd

  Section "German" SecGerman
  SectionIn 1 2
  SetOutPath "$INSTDIR\Plugins\Album List\Language"
  File "languages\german.al"
  SectionEnd

  Section "Hungarian" SecHungarian
  SectionIn 1 2
  SetOutPath "$INSTDIR\Plugins\Album List\Language"
  File "languages\hungarian.al"
  SectionEnd

  Section "Italian" SecItalian
  SectionIn 1 2
  SetOutPath "$INSTDIR\Plugins\Album List\Language"
  File "languages\italian.al"
  SectionEnd

  Section "Japanese" SecJapanese
  SectionIn 1 2
  SetOutPath "$INSTDIR\Plugins\Album List\Language"
  File "languages\japanese.al"
  SectionEnd

  Section "Korean" SecKorean
  SectionIn 1 2
  SetOutPath "$INSTDIR\Plugins\Album List\Language"
  File "languages\korean.al"
  SectionEnd

  Section "Polish" SecPolish
  SectionIn 1 2
  SetOutPath "$INSTDIR\Plugins\Album List\Language"
  File "languages\polish.al"
  SectionEnd

  Section "Portuguese" SecPortuguese
  SectionIn 1 2
  SetOutPath "$INSTDIR\Plugins\Album List\Language"
  File "languages\portuguese.al"
  SectionEnd

  Section "Romanian" SecRomanian
  SectionIn 1 2
  SetOutPath "$INSTDIR\Plugins\Album List\Language"
  File "languages\romanian.al"
  SectionEnd

  Section "Russian" SecRussian
  SectionIn 1 2
  SetOutPath "$INSTDIR\Plugins\Album List\Language"
  File "languages\russian.al"
  SectionEnd

  Section "Spanish" SecSpanish
  SectionIn 1 2
  SetOutPath "$INSTDIR\Plugins\Album List\Language"
  File "languages\spanish.al"
  SectionEnd

  Section "Swedish" SecSwedish
  SectionIn 1 2
  SetOutPath "$INSTDIR\Plugins\Album List\Language"
  File "languages\swedish.al"
  SectionEnd

  Section "Turkish" SecTurkish
  SectionIn 1 2
  SetOutPath "$INSTDIR\Plugins\Album List\Language"
  File "languages\turkish.al"
  SectionEnd

SubSectionEnd

SubSection "Additional File Format Support" SecFileFormat

  Section "OGG"
    SectionIn 1 2
    SetOutPath "$INSTDIR\Plugins\Album List\Plugins"
    File OGG\Release\ogg.afp
    RegDLL "$INSTDIR\Plugins\Album List\Plugins\ogg.afp" Install
  SectionEnd
  
  Section "FLAC"
    SectionIn 1 2
    SetOutPath "$INSTDIR\Plugins\Album List\Plugins"
    File FLAC\Release\flac.afp
  RegDLL "$INSTDIR\Plugins\Album List\Plugins\flac.afp" Install
  SectionEnd

SubSectionEnd
  
Section "Control Executables" SecControlExe
  SectionIn 1 2
  SetOutPath "$INSTDIR\Plugins\Album List\Control Executables"
  File "Control Executable\NextAlbum\Release\NextAlbum.exe"
  File "Control Executable\PrevAlbum\Release\PrevAlbum.exe"
  File "Control Executable\PlayAlbum\Release\PlayAlbum.exe"
SectionEnd

Section "Skin Template" SecTemplateSkin
  SectionIn 1
  SetOutPath "$INSTDIR\Plugins\Album List\Templates"
  File albumlist.bmp
  File albumlist.txt
SectionEnd

SubSection "3rd party support" Sec3rdParty

  Section "ATI Remote Wonder Support"
    WriteRegDWORD HKCU "Software\ATI Technologies\Multimedia\Remote Control\Plug-Ins\Album List for Winamp" "A" 0
    WriteRegDWORD HKCU "Software\ATI Technologies\Multimedia\Remote Control\Plug-Ins\Album List for Winamp" "B" 0
    WriteRegDWORD HKCU "Software\ATI Technologies\Multimedia\Remote Control\Plug-Ins\Album List for Winamp" "C" 0
    WriteRegDWORD HKCU "Software\ATI Technologies\Multimedia\Remote Control\Plug-Ins\Album List for Winamp" "D" 0
    WriteRegDWORD HKCU "Software\ATI Technologies\Multimedia\Remote Control\Plug-Ins\Album List for Winamp" "E" 0
    WriteRegDWORD HKCU "Software\ATI Technologies\Multimedia\Remote Control\Plug-Ins\Album List for Winamp" "F" 0
    WriteRegDWORD HKCU "Software\ATI Technologies\Multimedia\Remote Control\Plug-Ins\Album List for Winamp" "Enabled" 1
    WriteRegStr   HKCU "Software\ATI Technologies\Multimedia\Remote Control\Plug-Ins\Album List for Winamp" "Filename" "$INSTDIR\Plugins\gen_m3a.dll"
  SectionEnd

  Section "Lucidamp3 Support"
    WriteRegStr   HKCU "Software\LucidAmp\Album List" "Class" "Winamp AL"
    WriteRegDWORD HKCU "Software\LucidAmp\Album List" "Delay" 1
    WriteRegStr   HKCU "Software\LucidAmp\Album List" "File" "gen_m3a.dll"
  SectionEnd

SubSectionEnd

Section -post
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Album List" \
                   "Contact" "tfma@hotmail.com"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Album List" \
                   "DisplayIcon" "$INSTDIR\Plugins\uninstall-AL.exe"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Album List" \
                   "DisplayName" "Album List for Winamp v${VER_MAJOR}.${VER_MINOR} (remove only)"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Album List" \
                   "DisplayVersion" "${VER_MAJOR}.${VER_MINOR}"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Album List" \
                   "HelpLink" "http://come.to/albumlist"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Album List" \
                   "Publisher" "Safai Ma"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Album List" \
                   "Readme" "$INSTDIR\Plugins\Album List\readme.htm"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Album List" \
                   "UninstallString" "$INSTDIR\Plugins\uninstall-AL.exe"
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Album List" \
                   "VersionMajor" ${VER_MAJOR}
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Album List" \
                   "VersionMinor" ${VER_MINOR}
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Album List" \
                   "NoModify" 1
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Album List" \
                   "NoRepair" 1

  SetOutPath $INSTDIR
  Delete $INSTDIR\Plugins\uninstall-AL.exe 
  WriteUninstaller $INSTDIR\Plugins\uninstall-AL.exe
SectionEnd

;--------------------------------
;Descriptions

!insertmacro MUI_FUNCTIONS_DESCRIPTION_BEGIN
  !insertmacro MUI_DESCRIPTION_TEXT ${SecCore}         "The core files required to use Album List"
  !insertmacro MUI_DESCRIPTION_TEXT ${SecLanguages}    "Optional language files"
  !insertmacro MUI_DESCRIPTION_TEXT ${SecFileFormat}   "Provides support for reading file information"
  !insertmacro MUI_DESCRIPTION_TEXT ${SecControlExe}   "These executables allows you to control Album List from the command line"
  !insertmacro MUI_DESCRIPTION_TEXT ${SecTemplateSkin} "Skin templates for skinning Album List"
  !insertmacro MUI_DESCRIPTION_TEXT ${Sec3rdParty}     "Perform additional setup for 3rd party applications and plugins"
!insertmacro MUI_FUNCTIONS_DESCRIPTION_END
 
;--------------------------------
;Uninstaller Section

Section "Uninstall"

  IfFileExists $INSTDIR\gen_m3a.dll skip_confirmation
    MessageBox MB_YESNO "It does not appear that Album List is installed in the directory '$INSTDIR'.$\r$\nContinue anyway (not recommended)" IDYES skip_confirmation
    Abort "Uninstall aborted by user"
  skip_confirmation:

  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Album List"
  DeleteRegKey HKCU "Software\LucidAmp\Album List"
  DeleteRegKey HKCU "Software\ATI Technologies\Multimedia\Remote Control\Plug-Ins\Album List for Winamp"

  ; delete languages
  Delete "$INSTDIR\Album List\Language\bulgarian.al"
  Delete "$INSTDIR\Album List\Language\catalan.al"
  Delete "$INSTDIR\Album List\Language\czech.al"
  Delete "$INSTDIR\Album List\Language\danish.al"
  Delete "$INSTDIR\Album List\Language\dutch.al"
  Delete "$INSTDIR\Album List\Language\faroese.al"
  Delete "$INSTDIR\Album List\Language\finnish.al"
  Delete "$INSTDIR\Album List\Language\french.al"
  Delete "$INSTDIR\Album List\Language\german.al"
  Delete "$INSTDIR\Album List\Language\hungarian.al"
  Delete "$INSTDIR\Album List\Language\italian.al"
  Delete "$INSTDIR\Album List\Language\japanese.al"
  Delete "$INSTDIR\Album List\Language\korean.al"
  Delete "$INSTDIR\Album List\Language\polish.al"
  Delete "$INSTDIR\Album List\Language\portuguese.al"
  Delete "$INSTDIR\Album List\Language\romanian.al"
  Delete "$INSTDIR\Album List\Language\russian.al"
  Delete "$INSTDIR\Album List\Language\spanish.al"
  Delete "$INSTDIR\Album List\Language\swedish.al"
  Delete "$INSTDIR\Album List\Language\turkish.al"
  Delete "$INSTDIR\Album List\Language\simplified chinese.al"
  Delete "$INSTDIR\Album List\Language\traditional chinese.al"
  RMDir  "$INSTDIR\Album List\Language"

  ; delete plugins
  Delete "$INSTDIR\Album List\Plugins\flac.afp"
  Delete "$INSTDIR\Album List\Plugins\ogg.afp"
  RMDir  "$INSTDIR\Album List\Plugins"

  ; delete control executables
  Delete "$INSTDIR\Album List\Control Executables\PlayAlbum.exe"
  Delete "$INSTDIR\Album List\Control Executables\NextAlbum.exe"
  Delete "$INSTDIR\Album List\Control Executables\PrevAlbum.exe"
  RMDir  "$INSTDIR\Album List\Control Executables"

  ; delete templates
  Delete "$INSTDIR\Album List\Templates\export.htt"
  Delete "$INSTDIR\Album List\Templates\cover.htt"
  Delete "$INSTDIR\Album List\Templates\albumlist.bmp"
  Delete "$INSTDIR\Album List\Templates\albumlist.txt"
  RMDir  "$INSTDIR\Album List\Templates"

  ; delete readme and stuff
  Delete "$INSTDIR\Album List\readme.htm"
  Delete "$INSTDIR\Album List\nav_div.gif"
  Delete "$INSTDIR\Album List\nav_div_left.gif"
  Delete "$INSTDIR\Album List\nav_div_right.gif"
  Delete "$INSTDIR\Album List\searchpath.gif"
  Delete "$INSTDIR\Album List\history.txt"
  RMDir  "$INSTDIR\Album List"

  ; delete plugin
  Delete "$INSTDIR\Gen_m3a.dll"
  Delete "$INSTDIR\uninstall-AL.exe"

  ; delete settings
  MessageBox MB_YESNO|MB_ICONQUESTION \
             "Do you want to delete Album List settings?$\r$\n(No if you're upgrading)" \
             IDNO SaveSetting

  Delete "$INSTDIR\Gen_m3a.dat"
  DeleteINISec $INSTDIR\Plugin.ini "Album List"

  SaveSetting:
 
  ;Display the Finish header
  !insertmacro MUI_UNFINISHHEADER

SectionEnd

;--------------------------------
;Functions

Function .onInit

  ; - Is Winamp Running? -
  FindWindow $0 "Winamp v1.x"
  IsWindow $0 0 End

  ; - Winamp is Running -
  MessageBox MB_OKCANCEL|MB_ICONEXCLAMATION \
             "Winamp is currently running. Close it?" \
             IDCANCEL \
             TerminateInstall

  ; - Close Winamp -
  SendMessage $0 16 0 0

  ; - Set flag to re-start Winamp
  StrCpy $1 "Restart"  

  Goto End

  ; - User Decided to Abort -
  TerminateInstall:
  MessageBox MB_OK|MB_ICONSTOP "Winamp cannot be running during setup.$\r$\nAborting setup..."
  Abort

  ; - Carry on Install -  
  End:

FunctionEnd

Function .onVerifyInstDir
  IfFileExists $INSTDIR\Winamp.exe PathGood
  Abort

  PathGood:
FunctionEnd

Function un.onInit

  ; - Is Winamp Running? -
  FindWindow $0 "Winamp v1.x"
  IsWindow $0 0 End

  ; - Winamp is Running -
  MessageBox MB_OKCANCEL|MB_ICONEXCLAMATION \
             "Winamp is currently running. Close it?" \
             IDCANCEL \
             TerminateInstall

  ; - Close Winamp -
  SendMessage $0 16 0 0

  Goto End

  ; - User Decided to Abort -
  TerminateInstall:
  MessageBox MB_OK|MB_ICONSTOP "Winamp cannot be running during uninstall.$\r$\nAborting uninstall..."
  Abort

  ; - Carry on Uninstall -  
  End:
FunctionEnd
